<?php
namespace nur\sery\db;

/**
 * Class Capacitor: un objet permettant d'attaquer un canal spécique d'une
 * instance de {@link AbstractCapacitor}
 */
class Capacitor {
  function __construct(AbstractCapacitor $capacitor, CapacitorChannel $channel) {
    $this->capacitor = $capacitor;
    $this->channel = $channel;
  }

  /** @var AbstractCapacitor */
  protected $capacitor;

  /** @var CapacitorChannel */
  protected $channel;

  function exists(): bool {
    return $this->capacitor->_exists($this->channel);
  }

  function reset(): void {
    $this->capacitor->_reset($this->channel);
  }

  function charge($item, ?callable $func=null, ?array $args=null): bool {
    return $this->capacitor->_charge($this->channel, $item, $func, $args);
  }

  function discharge($filter=null, ?bool $reset=null): iterable {
    return $this->capacitor->_discharge($this->channel, $filter, $reset);
  }

  function get($filter) {
    return $this->capacitor->_get($this->channel, $filter);
  }

  function each($filter, callable $func, ?array $args=null): void {
    $this->capacitor->_each($this->channel, $filter, $func, $args);
  }

  function close(): void {
    $this->capacitor->close();
  }
}
